<?php

namespace Treewec\DirectoryIterators;

/**
 * Test class for MaxDepthAbortion.
 * Generated by PHPUnit on 2012-07-03 at 16:22:58.
 * @group directory_iterators
 */
class MaxDepthAbortionTest extends \PHPUnit_Framework_TestCase {

    /** @var Treewec\DirectoryIterators\MaxDepthAbortion */
    private $object;
    /** @var Treewec\DirectoryIterators\IteratorElement */
    private $iteratorElement;

    protected function setUp() {
        $this->object = new MaxDepthAbortion();
        $this->iteratorElement = new IteratorElement(5, new \SplFileInfo(TREEWEC_VIEW_DIR));
    }

    public function testAbortChildLoading() {
        // default value is 5
        $this->assert(5);
        // if number < 0 -> depth is not set
        $this->object->setMaxDepth(-5);
        $this->assert(5);
        // 0 is lowest number
        $this->object->setMaxDepth(0);
        $this->assert(0);
    }
    
    private function assert($borderValue) {
        $this->iteratorElement->depth = $borderValue;
        parent::assertFalse($this->object->abortChildLoading($this->iteratorElement));
        $this->iteratorElement->depth = $borderValue + 1;
        parent::assertTrue($this->object->abortChildLoading($this->iteratorElement));
    }

}

?>
